%define section   free
%define base_name   torque

Name:           db-%{base_name}
Version:        3.1.1
Release:        3jpp
Epoch:          0
Summary:        Torque persistence layer

Group:          Development/Libraries/Java
License:        Apache Software License
URL:            http://db.apache.org/torque/
Source0:        torque-3.1.1-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        db-torque-3.1.1-jpp-depmap.xml

Patch0:         torque-3.1-no-stratum.patch
Patch1:         db-torque-maven-plugin-3.1.1-plugin_jelly.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Distribution:   JPackage
Vendor:         JPackage Project

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  junit
BuildRequires:  maven
BuildRequires:  avalon-framework
BuildRequires:  avalon-logkit
BuildRequires:  gnu.getopt
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-configuration >= 0:1.0.f
BuildRequires:  jakarta-commons-dbcp
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-pool
BuildRequires:  jakarta-jcs
BuildRequires:  jdbc-stdext >= 0:2.0
BuildRequires:  jndi >= 0:1.2.1
BuildRequires:  log4j
BuildRequires:  village
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  avalon-framework
Requires:  avalon-logkit
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-configuration >= 0:1.0.f
Requires:  jakarta-commons-dbcp
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  jakarta-commons-pool
Requires:  jakarta-jcs
Requires:  jdbc-stdext >= 0:2.0
Requires:  jndi >= 0:1.2.1
Requires:  log4j
Requires:  village
Requires:  xerces-j2
Requires:  xml-commons-apis

%description
Torque is a persistence layer. Torque includes a 
generator to generate all the database resources 
required by your application and includes a 
runtime environment to run the generated classes. 

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%package        gen
Summary:        Generator for %{name}
Group:          Development/Libraries/Java

%description    gen
%{summary}.

%package        gen-javadoc
Summary:        Javadoc for %{name}-gen
Group:          Development/Documentation

%description    gen-javadoc
%{summary}.

%package        gen-manual
Summary:        Docs for %{name}-gen
Group:          Development/Documentation

%description    gen-manual
%{summary}.

%package        maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Libraries/Java

%description    maven-plugin
%{summary}.

%package        maven-plugin-manual
Summary:        Docs for %{name}-maven-plugin
Group:          Development/Documentation

%description    maven-plugin-manual
%{summary}.

%prep
%setup -q -n %{base_name}-%{version}-src
export DEPCAT=$(pwd)/db-torque-3.1.1-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > db-torque-3.1.1-depmap.new.xml


%patch0
%patch1

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags \


mkdir -p .maven/repository/JPP/jars
touch .maven/repository/JPP/jars/stratum.jar
build-jar-repository .maven/repository/JPP/jars \
gnu.getopt \


build-jar-repository -s -p .maven/repository/JPP/jars \
ant \
avalon-framework \
avalon-logkit \
commons-beanutils \
commons-collections \
commons-configuration \
commons-dbcp \
commons-lang \
commons-logging \
commons-pool \
jcs  \
jdbc-stdext \
jndi \
junit \
log4j \
velocity \
village \
xerces-j2 \
xml-commons-apis \


MAVEN_HOME_LOCAL=$(pwd)/.maven
pushd src/generator
maven -Dmaven.home.local=$MAVEN_HOME_LOCAL jar javadoc xdoc:transform
popd
cp src/generator/target/torque-gen-3.1.1.jar .maven/repository/JPP/jars/db-torque-gen.jar
pushd src/maven-plugin
maven -Dmaven.home.local=$MAVEN_HOME_LOCAL jar xdoc:transform
popd
maven -Dmaven.home.local=$MAVEN_HOME_LOCAL jar javadoc xdoc:transform

%install
rm -rf $RPM_BUILD_ROOT
install -Dpm 644 target/%{base_name}-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -Dpm 644 src/generator/target/%{base_name}-gen-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-gen-%{version}.jar
install -Dpm 644 src/maven-plugin/target/maven-torque-plugin-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/maven-torque-plugin-%{version}.jar

ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
ln -s %{name}-gen-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-gen.jar
ln -s maven-torque-plugin-%{version}.jar \
			$RPM_BUILD_ROOT%{_javadir}/maven-torque-plugin.jar

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
cp -pr src/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/profile
cp -pr profile/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


# generator javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
cp -pr src/generator/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
ln -s %{name}-gen-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen # ghost symlink
rm -rf src/generator/target/docs/apidocs

# generator manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}
cp -pr src/generator/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}

# maven-plugin manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}
cp -pr src/maven-plugin/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%post gen-javadoc
rm -f %{_javadocdir}/%{name}-gen
ln -s %{name}-gen-%{version} %{_javadocdir}/%{name}-gen


%files
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/*.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%files gen
%defattr(-,root,root,-)
%{_javadir}/%{name}-gen-%{version}.jar
%{_javadir}/%{name}-gen.jar

%files gen-javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-gen-%{version}
%ghost %doc %{_javadocdir}/%{name}-gen

%files gen-manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-gen-%{version}

%files maven-plugin
%defattr(-,root,root,-)
%{_javadir}/maven-torque-plugin-%{version}.jar
%{_javadir}/maven-torque-plugin.jar

%files maven-plugin-manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-maven-plugin-%{version}

%changelog
* Tue Nov 01 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-3jpp
- Change requirement from jakarta-turbine-jcs to jakarta-jcs

* Sat Mar 05 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-2jpp
- Fix problem with maven.home.local

* Mon Feb 21 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-1jpp
- Upgrade to 3.1.1
- Build with maven

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:3.1-2jpp
- Build with ant-1.6.2
- Relax some versioned requirements

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:3.1-1jpp
- First JPackage release.
